#include <windows.h>
#include <stdio.h>

typedef struct _bunpunode {
	int data;
	int kosuu;
	struct _bunpunode* prev;
	struct _bunpunode* next[2];
}bunpunode;

typedef struct {
	int size;
	char data[256];
}henkan;

int countbytes(unsigned int[256],HANDLE);
bunpunode* dohenkan(henkan[257],unsigned int[256]);
void freehenkan(bunpunode*);
unsigned int writekosuu(unsigned int[256],HANDLE);
unsigned int doassyuku(henkan[257],HANDLE,HANDLE);
unsigned int writeassyuku(HANDLE,henkan*,char[8],int*);
void* mycalloc(unsigned int);
void myfree(void*);

/*f[^k*/
unsigned int assyuku(HANDLE in,HANDLE out) {
	unsigned int kosuu[256]={0};
	henkan henkanlist[257];
	bunpunode* nodefirst;
	unsigned int wrotedata=0;
	/*ꂼ̃f[^邩*/
	if(countbytes(kosuu,in))return 0xFFFFFFFF;
	/*ϊ\쐬*/
	nodefirst=dohenkan(henkanlist,kosuu);
	/*ꗗo͂*/
	wrotedata+=writekosuu(kosuu,out);
	/*k*/
	wrotedata+=doassyuku(henkanlist,in,out);
	/*ϊ\*/
	freehenkan(nodefirst);
	/*񂾃oCgԂ*/
	return wrotedata;
}

/*ꂼ̃f[^邩*/
int countbytes(unsigned int kosuu[256],HANDLE fp) {
	unsigned int i;
	unsigned int size;
	unsigned char c;
	unsigned int read;
	size=GetFileSize(fp,NULL);
	if(size==0xFFFFFFFF)return 1;
	SetFilePointer(fp,FILE_BEGIN,NULL,0);
	for(i=0;i<size;i++) {
		ReadFile(fp,&c,1,(DWORD*)&read,NULL);
		kosuu[c]++;
	}
	return 0;
}

/*ϊ\쐬*/
bunpunode* dohenkan(henkan henkanlist[257],unsigned int kosuu[256]) {
	bunpunode* sublist[257];
	bunpunode* forhenkanlist[257];
	bunpunode* temp;
	int i,j;
	int max;
	/*IR[h*/
	sublist[0]=mycalloc(sizeof(bunpunode));
	sublist[0]->data=-1;
	sublist[0]->kosuu=1;
	/*ꂼ̃f[^̐*/
	for(i=0;i<256;i++) {
		sublist[i+1]=mycalloc(sizeof(bunpunode));
		sublist[i+1]->data=i;
		sublist[i+1]->kosuu=kosuu[i];
	}
	/*XgRs[*/
	for(i=0;i<257;i++)forhenkanlist[i]=sublist[i];
	/*}\[g()*/
	for(i=1;i<257;i++) {
		temp=sublist[i];
		for(j=i-1;j>=0;j--) {
			if(sublist[j]->kosuu<=temp->kosuu)break;
			sublist[j+1]=sublist[j];
		}
		sublist[j+1]=temp;
	}
	/*vf珇ɂȂ*/
	for(i=256;i>0;i--) {
		temp=mycalloc(sizeof(bunpunode));
		temp->data=-2;
		temp->kosuu=sublist[i-1]->kosuu+sublist[i]->kosuu;
		temp->next[0]=sublist[i-1];
		temp->next[1]=sublist[i];
		sublist[i-1]->prev=temp;
		sublist[i]->prev=temp;
		for(j=i-2;j>=0;j--) {
			if(sublist[j]->kosuu<=temp->kosuu)break;
			sublist[j+1]=sublist[j];
		}
		sublist[j+1]=temp;
	}
	/*ϊ\쐬*/
	for(i=0;i<257;i++) {
		temp=forhenkanlist[i];
		for(henkanlist[i].size=0;temp->prev!=NULL;henkanlist[i].size++) {
			if(temp==temp->prev->next[0])
				henkanlist[i].data[henkanlist[i].size]=0;
			else if(temp==temp->prev->next[1])
				henkanlist[i].data[henkanlist[i].size]=1;
			temp=temp->prev;
		}
	}
	/*ŏ̗vfԂ*/
	return sublist[0];
}

/*ϊXg*/
void freehenkan(bunpunode* ptr) {
	if(ptr->next[0]!=NULL)freehenkan(ptr->next[0]);
	if(ptr->next[1]!=NULL)freehenkan(ptr->next[1]);
	myfree(ptr);
}

/*o񐔂̏*/
unsigned int writekosuu(unsigned int kosuu[256],HANDLE out) {
	unsigned int allwrote=0,wrote;
	int i;
	unsigned int data;
	unsigned char towrite;
	for(i=0;i<256;i++) {
		data=kosuu[i];
		do {
			towrite=data & 0x7F;
			if((data=data>>7)>0)towrite|=0x80;
			WriteFile(out,&towrite,sizeof(char),(DWORD*)&wrote,NULL);
			allwrote+=wrote;
		} while(data>0);
	}
	return allwrote;
}

/*k*/
unsigned int doassyuku(henkan henkanlist[257],HANDLE in,HANDLE out) {
	unsigned int i;
	unsigned int size;
	unsigned char c;
	unsigned int read;
	unsigned int allwrote=0,wrote;
	char buf[8];
	int bufsize=0;
	size=GetFileSize(in,NULL);
	if(size==0xFFFFFFFF)return 1;
	SetFilePointer(in,FILE_BEGIN,NULL,0);
	for(i=0;i<size;i++) {
		ReadFile(in,&c,1,(DWORD*)&read,NULL);
		allwrote+=writeassyuku(out,&henkanlist[(int)c+1],buf,&bufsize);
	}
	/*IR[h*/
	allwrote+=writeassyuku(out,&henkanlist[0],buf,&bufsize);
	/*obt@̎c*/
	if(bufsize>0) {
		c=0;
		for(i=0;i<bufsize;i++) {
			c|=buf[i]<<i;
		}
		WriteFile(out,&c,sizeof(char),(DWORD*)&wrote,NULL);
		allwrote+=wrote;
	}
	return allwrote;
}

/*kf[^*/
unsigned int writeassyuku(HANDLE out,henkan* hk,char buf[8],int* bufsize) {
	int i,j;
	unsigned char c;
	unsigned int allwrote=0,wrote;
	for(i=hk->size-1;i>=0;i--) {
		buf[*bufsize]=hk->data[i];
		(*bufsize)++;
		if(*bufsize>=8) {
			c=0;
			for(j=0;j<8;j++) {
				c|=buf[j]<<j;
			}
			WriteFile(out,&c,sizeof(char),(DWORD*)&wrote,NULL);
			allwrote+=wrote;
			*bufsize=0;
		}
	}
	return allwrote;
}

/*m*/
void* mycalloc(unsigned int size) {
	return HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,size);
}

/**/
void myfree(void* ptr) {
	HeapFree(GetProcessHeap(),0,ptr);
}
